//
//  SNP.h

#ifndef SNP_H_INCLUDED
#define SNP_H_INCLUDED


#include <stdlib.h>
#include <inttypes.h>
#include <stdint.h>
#include <cmath> // for log2f


#include "../minia/Bloom.h"
#include "../minia/Kmer.h"
#include "Kmer_for_kissnp2.h"
#include "../minia/Set.h"
#include "../minia/Bank.h"


class Bubble{

protected:

    BinaryBank *SolidKmers;
    Bloom *bloom_solid_kmers;
    Set *debloom;
    bool extend_snps;
    int min_size_extension;
    void print_sequence_and_eventually_contigs(const char * path1, const char * path2, const int score);
    unsigned char branching_structure(kmer_type graine);
    bool close_snp(char * path1, char * path2, char * path1_c, char * path2_c);
public:
    void find_bubbles(const char * SNP_file_name, int low, int no_branching);
    void start_SwitchingNode(kmer_type graine);
    void start_Bubble(kmer_type graine, int low, int no_branching);
//    void expand_Bubble_till_SN(int direction, char* path1, char* path2, kmer_type kmer1, kmer_type kmer2, int pos);
    void expand_Bubble(int direction, char* path1, char* path2, kmer_type kmer1, kmer_type kmer2, int pos, char* p1, char* p2, char* p3, char* p4, int low, int no_branching);
    bool next(kmer_type *kmer);
    void read_bubble_file(char *bubble_filename);

    Bubble(BinaryBank *given_SolidKmers, Bloom *given_bloom, Set *given_debloom, bool extend_snps, int min_size_extension) : SolidKmers(given_SolidKmers), bloom_solid_kmers(given_bloom), debloom(given_debloom), extend_snps(extend_snps), min_size_extension(min_size_extension) { }
    Bubble() { }
};


#endif // SNP_H_INCLUDED
